
/* ********************************************* */
/* *   Implementation of class   Heap          * */
/* ********************************************* */

template<class T>
bool Heap<T> ::isUpdate(int weight, int index)
{
  if(array[index].weight > weight) return true;
  else return false; 
}
template<class T>
bool Heap<T> ::insert(HeapNode& ele,std::vector<StateHeap<T> >& s)
{
  int pos=0;
  //array[0] for "sentinent"
  if(numEle>=int(array.size()-1)) return false;
  ++numEle;

  array[numEle] = ele;
  upHeap(numEle,pos, s);
  s[ele.index].indexHeap = pos;
  return true; 
}
template<class T>
void Heap<T> ::upHeap(int k,int& pos,std::vector<StateHeap<T> >& s)
{
  HeapNode x = array[k];
  array[0].weight = -1;
  while(array[k/2].weight > x.weight)
    {  
       array[k] = array[k/2]; 
       s[array[k/2].index].indexHeap = k; 
       k = k / 2;
    }
 
  array[k] = x;
  pos = k;
}
template<class T>
void Heap<T> ::downHeap(int k,std::vector<StateHeap<T> >& s)
{
   int j;
   HeapNode x = array[k];
   while(k<=(numEle/2))
     {
       j= k+k;
       if(j<numEle)
         if(array[j].weight > array[j+1].weight) ++j;
       if(x.weight <= array[j].weight) break;
       
       array[k] = array[j];
       s[array[j].index].indexHeap = k; 
       k=j;
     }

   array[k] = x; 
   s[x.index].indexHeap  = k;
}
template<class T>
bool Heap<T> ::remove(HeapNode& r, std::vector<StateHeap<T> >& s)
{
    if(numEle<=0) return false; 
    r = array[1];
    s[array[1].index].indexHeap = s[array[numEle].index].indexHeap; 
    array[1] = array[numEle];
    --numEle;
    downHeap(1,s);
    return true;
}
template<class T>
bool Heap<T> ::deleteD(int k, std::vector<StateHeap<T> >& s)
{
    if(numEle<=0) return false; 
    s[array[k].index].indexHeap = s[array[numEle].index].indexHeap;
    array[k] = array[numEle];
    --numEle;
    downHeap(k,s);
    return true;
} 

/* ********************************************* */
/* *   Implementation of class   TreeLabel     * */
/* ********************************************* */

bool TreeLabel::testWord(bool point=false)
{
  for(int unsigned j=0;j<infixSerie.size();++j)
    {
      if(!point)
	{
         if(infixSerie[j]==")"||infixSerie[j]=="("||isSymbol(infixSerie[j][0]))
         return false;
	}
      else
	{
         if(infixSerie[j]==")"||infixSerie[j]=="("||
            (isSymbol(infixSerie[j][0])&&infixSerie[j]!="."))
         return false;
	}
    }   
  return true;
}

//empty word is alpha[0]
int TreeLabel::test(std::vector<string>& ex, std::vector<string>& alpha, 
                    bool skip=false)
{
  if(ex.size()<=0) return 1;
  unsigned int i,j;
  unsigned int size=ex.size();
  std::vector<string> exp =std::vector<string>(size);
  unsigned int sizeEx=exp.size();
  
  //add operator "/"
  j=0;
  for(i=0;i<size;++i)
  { 
   if(ex[i][0]==STAR && i+1<size)
    if(!isSymbol(ex[i+1][0])&&ex[i+1]!=")") 
      { exp.resize(++sizeEx);  
        exp[j++] = ex[i]; 
        exp[j++] = "/";
        continue;}  
   if(ex[i]==")"&&i+1<size)
        if(!isSymbol(ex[i+1][0])&&ex[i+1]!=")")
      { exp.resize(++sizeEx); 
        exp[j++] = ex[i]; 
        exp[j++] = "/"; 
        continue;}   
   if(!isSymbol(ex[i][0])&&i+1<size&&ex[i]!="("&&ex[i]!=")" )
        if(!isSymbol(ex[i+1][0])&&ex[i+1]!=")" )
      { exp.resize(++sizeEx);  
        exp[j++] = ex[i]; 
        exp[j++] = "/";  
        continue;} 
   exp[j++] = ex[i];    
  }

  if(!skip)                      
  for(int unsigned j=0;j<exp.size();++j)
    {
      if(exp[j]!=")"&&exp[j]!="("&&exp[j][0]!=STAR&&
         exp[j][0]!=ADDITION&&exp[j][0]!=PRODUCT)
      if(find(alpha.begin(),alpha.end(),exp[j])==alpha.end()) return -1;
    }
  

  int error = 0;
  TreeLabel dummy = TreeLabel(); 
  NodeTree* tree  = dummy.reTreeLabel(NULL,0,(int)exp.size()-1,exp, error);
  delete(tree);

  if(error!=0) return -1;
  else return 1; 
  return 1;  //good
}

bool TreeLabel::isEmptyWord(string& w) const
{
  if(w==emptyWord) return true;
  else return false;
}

string TreeLabel::getEmptyWord(void) const
{
  return emptyWord;
}

void TreeLabel::setEmptyWord(string w)
{
  emptyWord = w;
}

//"ex" can include the empty word that is considered an operand !  
TreeLabel::TreeLabel(std::vector<string>& ex, char empty=EMPTY_WORD)
{
  unsigned int i=0,j=0;
  unsigned int size=ex.size();
  std::vector<string> exp =std::vector<string>(size);
  unsigned int sizeEx=exp.size();
  emptyWord = "";emptyWord = emptyWord + empty;
  
  if(ex.empty()) 
    {
      this->tree = NULL;
      this->infixSerie.resize(0);
      this->zero = false;
      return;
    } 
  j=0; 
  //add the operator "/"
  for(i=0;i<size;++i)
  { 
   if(ex[i][0]==STAR && i+1<size)
    if(!isSymbol(ex[i+1][0])&&ex[i+1]!=")") 
      { exp.resize(++sizeEx);
        exp[j++] = ex[i]; 
        exp[j++] = "/";
        continue;}  
   if(ex[i]==")"&&i+1<size)
        if(!isSymbol(ex[i+1][0])&&ex[i+1]!=")")
      { exp.resize(++sizeEx);
        exp[j++] = ex[i];  
        exp[j++] = "/"; 
        continue;}   
   if(!isSymbol(ex[i][0])&&i+1<size&&ex[i]!="("&&ex[i]!=")" )
        if(!isSymbol(ex[i+1][0])&&ex[i+1]!=")" )
      { exp.resize(++sizeEx);
        exp[j++] = ex[i];  
        exp[j++] = "/";  
        continue;}  
   exp[j++] = ex[i];  
  }

  //cout<<"expression=";
  //for(i=0;i<exp.size();++i)
  //cout<<exp[i]<<" ";

  int error = 0;  
  this->tree = reTreeLabel(NULL,0,(int)exp.size()-1,exp, error);  
  infixSerie = createInfixSerie(this->tree);

  // cout<<"infix="<<infixSerie[0]<<endl;
  this->zero = false; 
} 

NodeTree* TreeLabel::reTreeLabel(NodeTree* p,int l,int r,
                     std::vector<string>& ex,int& error)
{
  int i=0;
  int prioIndex=0;
  int prio; 
  
  if(l>r) return NULL;

  if(r==l&&!isSymbol(ex[l][0])) 
    {
      if(ex[l]=="("||ex[l]==")") {error = 1;return NULL;} 
      NodeTree* tmp = new NodeTree(ex[l], false, NULL,NULL,p);
      return tmp;
    }
  if(r==l&&isSymbol(ex[l][0]) )
  {
    error=1;
    return NULL;
  }  

  int unsigned nb=0; i = r;
  if(ex[r]==")")
        { 
          nb = 1;
          while(i>=l&&nb>0) 
	    { --i;if(i<l) {error = 1;return NULL;} 
              if(ex[i]==")") ++nb; 
              if(ex[i]=="(") --nb; 
             
            }
          if(nb!=0) {error = 1;return NULL;}
          if(nb==0&&i<=l) 
            { 
              NodeTree* tmp = reTreeLabel(p,l+1,r-1,ex,error);
              if(error) return NULL;
              return tmp;
            }
        } 
 
  //find symbol with the smallest priority 
  prio = STAR_PRIORITY; 
  prioIndex=-1;
  bool meet=false;
  i = r;
  nb=0;
  while(i>=l)
    {
      if(ex[i]==")")
        { 
          nb = 1;
          while(i>=l&&nb>0) 
	    { i--; if(i<l) {error = 1;return NULL;}
              if(ex[i]==")") ++nb; 
              if(ex[i]=="(") --nb; 
            }
          if(nb!=0) {error = 1;return NULL;} 
        } 
     
      if(isSymbol(ex[i][0]))
	{
	 if(!meet) { prioIndex = i; meet=true;}       
         if( getPrio(ex[i][0]) < (unsigned int)prio) 
           { prio =  getPrio(ex[i][0]);prioIndex = i;}
	}
  
      --i;
    }

  if(prioIndex==-1) {error = 1;return NULL;} 
  //cout<<"\noper = "<<prioIndex<<endl<< flush;cout << "\n left " << flush;
  NodeTree* tmp = new NodeTree(ex[prioIndex], true, NULL,NULL,p);
  tmp->left =reTreeLabel(tmp,l,prioIndex - 1,ex,error);
  if(error) return NULL; 
  if((ex[prioIndex][0]==ADDITION||ex[prioIndex][0]==PRODUCT)&&tmp->left==NULL)
    {error=1;return NULL;}
  tmp->right=reTreeLabel(tmp,prioIndex + 1,r,ex,error);
  if(error) return NULL;
  if((ex[prioIndex][0]==ADDITION||ex[prioIndex][0]==PRODUCT)&&tmp->right==NULL)
    {error=1;return NULL;} 
  return tmp;
}

string TreeLabel::getInfixString(void) const
{
  std::vector<string> tmp = this->getInfixSerie();
  string s = "";
  if(tmp.size()==1&&isEmptyWord(tmp[0])) return "";;
  for(int unsigned i=0;i<tmp.size();++i) 
       s = s + tmp[i];
  return s;
}

unsigned int TreeLabel::getPrio(char a)
{
  if(a==STAR)        return STAR_PRIORITY;
  if(a==COMPLEMENT)   return COMPLEMENT_PRIORITY;
  if(a==PRODUCT)      return PRODUCT_PRIORITY;
  if(a==SUBTRACTION)  return SUBTRACTION_PRIORITY;
  if(a==ADDITION)     return ADDITION_PRIORITY;
  if(a==INTERSECTION) return INTERSECTION_PRIORITY;
  return 0;
}

bool TreeLabel::isSymbol(char a)
{
  if(a==STAR)        return true;
  if(a==COMPLEMENT)   return true;
  if(a==PRODUCT)      return true;
  if(a==ADDITION)     return true;
  if(a==SUBTRACTION)  return true;
  if(a==INTERSECTION) return true;
  return false;
}

std::vector<string>  TreeLabel::createInfixSerie(NodeTree* t)
{
  int unsigned size=0;
  std::vector<string> s = std::vector<string>(0) ;
  if(t==NULL) return s;
  if(t->parent!=NULL)
     if(isSymbol(t->symbolS[0])&&
        getPrio(t->parent->symbolS[0]) > getPrio(t->symbolS[0]) )
       {
         s.insert(s.end(),"(");
       }

  std::vector<string> tmp = this->createInfixSerie(t->left);
  s.insert(s.end(),tmp.begin(),tmp.end());
  if(t->symbolS[0]!=PRODUCT) s.insert(s.end(),t->symbolS);
  tmp = this->createInfixSerie(t->right);
  s.insert(s.end(),tmp.begin(),tmp.end());
  if(t->parent!=NULL)
     if(isSymbol(t->symbolS[0])&&getPrio(t->parent->symbolS[0]) >
        getPrio(t->symbolS[0]) )
       s.insert(s.end(),")"); 

  return s;
}

NodeTree* TreeLabel::copyTree(NodeTree* t,NodeTree* parent)
{
  if(t==NULL) return NULL; 

  NodeTree* tmp = new NodeTree(t->symbolS,
            t->isSymbol,NULL,NULL,parent);

  tmp->left  = copyTree(t->left, tmp);
  tmp->right = copyTree(t->right, tmp);
  return tmp;
}

TreeLabel::TreeLabel(const TreeLabel& treeLab)
{
  this->infixSerie = treeLab.infixSerie;
  this->tree       = this->copyTree(treeLab.tree,NULL);
  this->emptyWord  = treeLab.getEmptyWord();
  this->zero       = treeLab.zero;
}

void TreeLabel::operator = (const TreeLabel& p1)
{
  this->delTree(this->tree);
  this->tree=copyTree(p1.tree,NULL);
  this->infixSerie = p1.infixSerie;
  this->emptyWord  = p1.getEmptyWord();
  this->zero       = p1.zero;
}

void TreeLabel::delTree(NodeTree* t)
{
  if(t==NULL) return;
  delTree(t->left);
  delTree(t->right);
  delete t;
}

TreeLabel::~TreeLabel()
{
   delTree(this->tree);  
}

bool TreeLabel::operator == (const TreeLabel& p1)
{ 
     if(this->empty()&&p1.empty()) return true;
     if(this->infixSerie==p1.infixSerie&&this->zero==p1.zero) 
        return true;
     else 
        return false;
}

bool TreeLabel::empty(void) const
{
     if(zero) return false;
     // infixSerie.size == 0
     if(infixSerie.empty()) return true; //for empty word of automaton  
     // expression have the empty word only 
     string s = infixSerie[0];
     if(infixSerie.size()==1&&isEmptyWord(s)) return true;
     else return false;
}

bool TreeLabel::isZero(void) const//zero element
{
  return zero;
}

bool TreeLabel::operator < (const TreeLabel& p1) const
{
     if(this->infixSerie < p1.infixSerie) return true;
     else return false;
}

//very interesting ! 
//expression is displayed no blanc !
static std::ostream& operator << (std::ostream& out,const TreeLabel& n)
{
  string s;
  if(n.isZero()) s="zero";
  //else if(n.empty()) s = n.getEmptyWord();
  else s = n.getInfixString(); 
  out << s; 
  return out;
}

TreeLabel TreeLabel::operator * (void)
{
   std::vector<string>    infix;
   if(this->isZero()) { TreeLabel tmp = TreeLabel(true); return tmp;}
   TreeLabel t(*this);
   if(this->empty()) 
     { 
        char emp = this->getEmptyWord()[0];   
        TreeLabel tmp  = TreeLabel(emp); 
        return tmp;
     }
   std::vector<string> exp = this->getInfixSerie();
   infix.insert(infix.end(),"("); 
   infix.insert(infix.end(),exp.begin(),exp.end());
   infix.insert(infix.end(),")");
   infix.insert(infix.end(),"*");  
   
   char emp = this->getEmptyWord()[0];    
   TreeLabel tmp(infix,emp);
   return tmp;
}

TreeLabel TreeLabel::operator + (const TreeLabel& p)
{
   if(p.isZero()) { return (*this); }
   if(this->isZero()) { return p; }

   //if(this->getEmptyWord()!=p.getEmptyWord())
   //  {
   //    cout<<"Addition operation on 2 ops with various empty words !"<<endl;
   //    return (*this); 
   //  }

   std::vector<string>  infix;
   TreeLabel t(p);
   std::vector<string> u = this->getInfixSerie();
   std::vector<string> v = p.getInfixSerie();
   if(this->empty()&& p.empty()) 
      {
        char emp = this->getEmptyWord()[0];   
        TreeLabel tmp  = TreeLabel(emp); 
        return tmp; 
      }

   if(this->empty()) { u.resize(0); u.insert(u.end(),this->emptyWord);}
   if(p.empty()) { v.resize(0); v.insert(v.end(),this->emptyWord);}
 
   infix.insert(infix.end(),"("); 
   infix.insert(infix.end(),u.begin(),u.end());
   infix.insert(infix.end(),")");
   infix.insert(infix.end(),"+");
   infix.insert(infix.end(),"("); 
   infix.insert(infix.end(),v.begin(),v.end());
   infix.insert(infix.end(),")");

   char emp = this->getEmptyWord()[0];   
   TreeLabel tmp(infix,emp);
   return tmp;
}

TreeLabel TreeLabel::operator / (const TreeLabel& p)
{
   if(p.isZero()||this->isZero()) { TreeLabel tmp(true); return tmp;}

   if(this->empty()) {return p;}
   if(p.empty())     {return (*this);}

   std::vector<string> infix;
   
   infix.insert(infix.end(),"("); 
   
   std::vector<string> left = this->getInfixSerie();

   infix.insert(infix.end(),left.begin(),left.end());

   std::vector<string> right = p.getInfixSerie();
   infix.insert(infix.end(),")");
   infix.insert(infix.end(),"/");
   infix.insert(infix.end(),"("); 
   infix.insert(infix.end(),right.begin(),right.end());
   infix.insert(infix.end(),")");

   char emp = this->getEmptyWord()[0];   
   TreeLabel tmp(infix,emp);
   return tmp;
}

TreeLabel TreeLabel::linearize(std::map<string,string>& h, 
                               std::vector<string>& alpha)
{  
   int c = 0;
   std::vector<string> exp;
   string tmp;
   for(int unsigned i=0;i<this->getInfixSize();++i)
     {   
      if(infixSerie[i]!="("&&infixSerie[i]!=")"&&
         !isSymbol(infixSerie[i][0]))
	{
          ++c; 
          string index = "x" + intToString(c);
          h[index] = infixSerie[i];
          tmp = index;
	} 
      else tmp = infixSerie[i];

      exp.insert(exp.end(),tmp);
     } 
   char emp = this->getEmptyWord()[0];  
   TreeLabel linear = TreeLabel(exp, emp);
   return linear;   
}

bool TreeLabel::reLambdaOfExp(NodeTree* t) const
{
  if(t==NULL) return true;
  if(isSymbol(t->symbolS[0]))
    {
     if(t->symbolS[0]==STAR) return true;
     if(t->symbolS[0]==ADDITION)
       {
         bool l = reLambdaOfExp(t->left);
         bool r = reLambdaOfExp(t->right);
         return (l||r);
       }
     if(t->symbolS[0]==PRODUCT)
       {
         bool l = reLambdaOfExp(t->left);
         bool r = reLambdaOfExp(t->right);
         return (l&&r);
       }
     return false; 
    }
  else return false; 
}

bool TreeLabel::lambdaOfExp(void) const
{
  if(this->isZero()) return false;
  if(this->empty())  return true; 
  return (reLambdaOfExp(tree)); 
}

void TreeLabel::createCMap(TreeLabel& linear,std::map<string,ConFirst>& cMap)
{
  ConFirst conf;
  linear.firstSet(conf.first);   
  conf.tree = linear;
  cMap["x0"] = conf; 
  
  std::map<string,string>::iterator ih;
  ListOfSymbols first;
  std::list<NodeTree*> vars;
  std::list<NodeTree*>::iterator iVar;

  linear.varList(vars);

  for(iVar=vars.begin();iVar!=vars.end();++iVar)
    {
       first.clear();

       if(!isEmptyWord((*iVar)->symbolS))//c_continuation of var non empty 
	 {  
           
           TreeLabel tmp = linear.c_continuation(*iVar,first);

           //cout<<"after c_continuation="<<(*iVar)->symbolS<<endl<<flush;
           //cout<<"c_con="<<tmp<<endl;
           //cout<<"first=";
           //ListOfSymbols::iterator ii;
           //for(ii=first.begin();ii!=first.end();++ii)
	   //	 cout<<"f1="<<*ii<<endl;
           //cout<<endl;

            if(!tmp.isZero())
	    {
              ConFirst con =  ConFirst(first,tmp);
              cMap[(*iVar)->symbolS] = con; 
	    } 
	 }
    }     
  
}

//rewrite, bad !
TreeLabel TreeLabel::c_continuation(NodeTree* var,ListOfSymbols& first)
{

   TreeLabel tmp(this->getEmptyWord()[0]); 
 
   std::list<TreeLabel> treeList;
   std::list<TreeLabel>::iterator j,i,r,s=treeList.end();
   int count=0, cr=0, cs=0;

   //cout<<"c_conthis="<<*this<<", var= "<<var->symbolS<<flush;
 
   std::vector<string> infix;
   while(var->parent!=NULL)
     {
        count++;  
        //cout<<"varLoop= "<<var->symbolS<<flush; 
        
        if(var->parent->symbolS[0]==PRODUCT&&var->parent->left==var)
	  {
            
            infix.clear();
            infix = createInfixSerie(var->parent->right);
           
            TreeLabel ancestor;
            if(!infix.empty()) 
               ancestor= TreeLabel(infix, this->getEmptyWord()[0]);
            else ancestor= TreeLabel(this->getEmptyWord()[0]);
            
            //cout<<"ancestor="<<ancestor<<endl<<flush;
            tmp = tmp / ancestor; 
            
            std::list<TreeLabel>::iterator f;
            f = treeList.insert(treeList.end(),ancestor);
           
            if(s==treeList.end()&&(!ancestor.lambdaOfExp())) 
              { s = f; cs=count; }
	  
          } 
        else if(var->parent->symbolS[0]==STAR)
	  {
            infix.clear();
            infix = createInfixSerie(var->parent);

            TreeLabel ancestor;
            if(!infix.empty()) 
               ancestor= TreeLabel(infix, this->getEmptyWord()[0]);
            else ancestor= TreeLabel(this->getEmptyWord()[0]);
           
            tmp = tmp / ancestor;  
            r = treeList.insert(treeList.end(),ancestor);
            cr = count;

            //cout<<"star= "<<ancestor<<flush; 

	  }
        var=var->parent;
     }

   //reserve for improvement
   if(cs==0)
     {
       if(cr==0) { r = treeList.begin();s = treeList.end();}
       else { s = treeList.end(); } // r->end()
     }
   else
     {
       if(cs<cr) { r = treeList.begin(); } //begin->s
       else 
         { 
           if(cr==0) { r = treeList.begin(); } //begin->s
         }
       //r->s
     }

   if(s!=treeList.end()) j = ++s; 
   else j=s;
   
   //cout<<"var= "<<var->symbolS<<" "<<flush;
   //cout<<"cx=";
   //cout<<tmp<<endl;
   //cout<<"cs= "<<cs<<", cr= "<<cr;
   //cout<<endl;
   
   for(i=r;i!=s;++i)
      {
       i->firstSet(first);

       //cout<<"exp=";i->print(i->getTree());
       //ListOfSymbols::iterator ii;
       //for(ii=first.begin();ii!=first.end();++ii)
       //	 cout<<"f2="<<*ii<<endl;
       //cout<<endl;

      }
   return tmp;
}

void TreeLabel::firstSet(ListOfSymbols& f)
{
  if(tree!=NULL)
    {
       
       std::vector<string> infix = createInfixSerie(tree->left);
       TreeLabel H = TreeLabel(infix,this->getEmptyWord()[0]);
       infix = createInfixSerie(tree->right);
       TreeLabel G = TreeLabel(infix,this->getEmptyWord()[0]);

       if(tree->symbolS[0]==PRODUCT)
         {
           if(H.lambdaOfExp()) 
             { 
               H.firstSet(f); 
               G.firstSet(f);
	     }
           else H.firstSet(f); 
	 }
       else if(tree->symbolS[0]==STAR)
	 { H.firstSet(f); G.firstSet(f);}
       else if(tree->symbolS[0]==ADDITION)
         { H.firstSet(f); G.firstSet(f);}
       else
         {
	   ListOfSymbols::iterator iL=f.begin();
           for(;iL!=f.end();++iL) if(*iL==tree->symbolS) break;     
              if(iL==f.end()) 
           f.insert(f.end(),tree->symbolS);
         }   
    }
}

//rewrite, bad !
void TreeLabel::cMapToQuoMap(std::map<string,ConFirst>& cMap,
     std::map<string,string>& h,std::map<TreeLabel,ListOfSymbols>& quoMap)
{
  std::map<string,ConFirst>::iterator ic;
  for(ic=cMap.begin();ic!=cMap.end();++ic)
    {
      TreeLabel tmp = ic->second.tree.toProjection(h);
      if(quoMap.find(tmp)!=quoMap.end())
	{ 
          quoMap[tmp].insert(quoMap[tmp].end(),ic->first); 
	}
      else 
        { 
	   ListOfSymbols l;
           l.insert(l.end(),ic->first);
           quoMap[tmp]=l;
	}  
    }
}

TreeLabel  TreeLabel::toProjection(std::map<string,string>& h)
{
   std::vector<string> exp;
   string tmp;
   int c=0;
   for(int unsigned i=0;i<this->getInfixSize();++i)
     {   
      if(infixSerie[i]!="("&&infixSerie[i]!=")"&&
         !isSymbol(infixSerie[i][0]))
	{
          tmp = h[infixSerie[i]];
	} 
      else tmp = infixSerie[i];

      exp.insert(exp.end(),tmp);
     } 
   char emp = this->getEmptyWord()[0];  
   TreeLabel linear = TreeLabel(exp,emp);
   return linear;   
}

void TreeLabel::reVarList(NodeTree* tree,std::list<NodeTree*>& l)
{
  if(tree!=NULL)
    {
      if(!(TreeLabel::isSymbol(tree->symbolS[0])))
         l.insert(l.end(),tree);
      reVarList(tree->left,l);
      reVarList(tree->right,l);
    }
}

void TreeLabel::varList(std::list<NodeTree*>& l)
{
  reVarList(tree,l);
}

//empty word for this function : TreeLabel::getEmptyWord() i.e = 1 or some other !!!
//empty word of automaton is ""
Automata<TreeLabel>* TreeLabel::expToAuto(string name,std::vector<string>&alpha)
{ 

  if(this->isZero()) return NULL;
 
  //infixSerie is empty or emptyWord!!!
  if(this->empty()) 
    { 
       Automata<TreeLabel>* autoTmp = new Automata<TreeLabel>(name,0,alpha);
       autoTmp->addState("1");
       autoTmp->setInitialState("1", alpha[0][0]);
       autoTmp->setTerminalState("1", alpha[0][0]);
       ListOfSymbols his;
       his.insert(his.end(), "expression");
       autoTmp->setHistOfITGraph(his);
       autoTmp->setHistType(EXPRESSION_HISTORY); 
       autoTmp->setNoInitStates();
       autoTmp->setNoTermStates();
       return autoTmp;
    }
  
  std::map<string,string> h;
  
  TreeLabel linear = this->linearize(h,alpha);
  
  Automata<TreeLabel>* autoTmp = new Automata<TreeLabel>(name,0,alpha);
  std::map<string,ConFirst> cMap;
  
  std::map<TreeLabel,int> stateMap;
  std::map<TreeLabel,ListOfSymbols> quoMap;

  this->createCMap(linear,cMap);
 
  this->cMapToQuoMap(cMap,h,quoMap);
 
   std::map<TreeLabel,ListOfSymbols>::iterator iMap,jMap;
  //create the states
  
  int count = 1;
  for(iMap = quoMap.begin();iMap!=quoMap.end();++iMap)
    {  

      ListOfSymbols hist; 
      hist.insert(hist.end(),iMap->first.getInfixString());
      stateMap[iMap->first] = count;
      string n = intToString(count++); 
      autoTmp->addState(n,hist,true); 
      if(*this==iMap->first) autoTmp->setInitialState(n, alpha[0][0]);
      if(iMap->first.lambdaOfExp()) 
         autoTmp->setTerminalState(n, alpha[0][0]);
    }

  //create the transitions

  for(iMap = quoMap.begin();iMap!=quoMap.end();++iMap)
    {
      ListOfSymbols::iterator iS;
      for(iS=iMap->second.begin();iS!=iMap->second.end();++iS)  
         {
          
           ListOfSymbols first = cMap[*iS].first;
           ListOfSymbols::iterator ifi;
           for(ifi=first.begin();ifi!=first.end();++ifi)
	     { 
               TreeLabel linear = cMap[*ifi].tree;
               TreeLabel exp = linear.toProjection(h);
               std::vector<string> expL;
               if(quoMap.find(exp)!=quoMap.end())
		 { 
                    string label="";label=label + h[*ifi];
 
		    expL.clear();
                    expL.insert(expL.end(),label);                    
                    TreeLabel lab = TreeLabel(expL,alpha[0][0]);
                    autoTmp->addTransition(intToString(stateMap[iMap->first]),
                             intToString(stateMap[exp]),lab);
		   
		 }
	     }     
	 }
    }

  ListOfSymbols his;
  his.insert(his.end(),"expression");
  autoTmp->setHistOfITGraph(his);
  autoTmp->setHistType(EXPRESSION_HISTORY);
  autoTmp->setNoInitStates();
  autoTmp->setNoTermStates();
  
  return autoTmp;
}

TreeLabel TreeLabel::reChoiceWord(NodeTree* t)
{
  TreeLabel departure = TreeLabel(this->getEmptyWord()[0]);
  if(t==NULL) return departure;
  if(!isSymbol(t->symbolS[0]))
    {
      std::vector<string> exp;
      exp.insert(exp.end(),t->symbolS);
      TreeLabel tmp = TreeLabel(exp,this->getEmptyWord()[0]);
      return tmp;
    }
  else if(t->symbolS=="*")
       return departure;
  else if(t->symbolS=="+")
       return reChoiceWord(t->left);
  else if(t->symbolS=="/") 
    {
      TreeLabel l = reChoiceWord(t->left);
      TreeLabel r = reChoiceWord(t->right);
      return (l/r);
    }
  return departure;
}

TreeLabel TreeLabel::choiceWord(void)
{

 TreeLabel departure = TreeLabel(this->getEmptyWord()[0]);
 if(this->empty()) return departure;
 return reChoiceWord(tree); 
}

string  TreeLabel::intToString(int i)
{
  string result;
  char media[2];
  
  if(i==0) 
  { 
    media[0] =  48;
    media[1] = '\0';
    string tmp = media;
    result = tmp + result;
    return result;
  }
 
  while(i!=0) 
  {
    media[0] = (i % 10) + '0';
    media[1] = '\0';
    string tmp = media;
    result = tmp + result;
    i = i / 10;
  }
  return result;
}

/*********************************************************************/
/*                     methodes of ExTreeLabel                       */
/*********************************************************************/

//"ex" can include the empty word that is considered an operand !  
ExTreeLabel::ExTreeLabel(std::vector<string>& ex, std::vector<string>& alpha,
                         char empty=EMPTY_WORD)
{
  unsigned int i=0,j=0;
  unsigned int size=ex.size();
  std::vector<string> exp =std::vector<string>(size);
  unsigned int sizeEx=exp.size();
  emptyWord = "";emptyWord = emptyWord + empty;
  alphaSet = alpha;  

  if(ex.empty()) 
    {
      this->tree = NULL;
      this->infixSerie.resize(0);
      this->zero = false;
      return;
    } 
  j=0; 
  //add the operator "/"
  for(i=0;i<size;++i)
  { 
   if(ex[i][0]==STAR && i+1<size)
    if(!isSymbol(ex[i+1][0])&&ex[i+1]!=")") 
      { exp.resize(++sizeEx);
        exp[j++] = ex[i]; 
        exp[j++] = "/";
        continue;}  
   if(ex[i][0]==STAR && i+1<size)
    if(ex[i+1][0]==COMPLEMENT) 
      { exp.resize(++sizeEx);  
        exp[j++] = ex[i]; 
        exp[j++] = "/";
        continue;}  
   if(ex[i]==")"&&i+1<size)
        if(!isSymbol(ex[i+1][0])&&ex[i+1]!=")")
      { exp.resize(++sizeEx);
        exp[j++] = ex[i];  
        exp[j++] = "/"; 
        continue;}   
   if(!isSymbol(ex[i][0])&&i+1<size&&ex[i]!="("&&ex[i]!=")" )
        if(!isSymbol(ex[i+1][0])&&ex[i+1]!=")" )
      { exp.resize(++sizeEx);
        exp[j++] = ex[i];  
        exp[j++] = "/";  
        continue;}  
   if(!isSymbol(ex[i][0])&&i+1<size&&ex[i]!="(")
        if(ex[i+1][0]==COMPLEMENT)
      { exp.resize(++sizeEx);
        exp[j++] = ex[i];  
        exp[j++] = "/";  
        continue;}  

   exp[j++] = ex[i];  
  }

  //cout<<"correct=";
  //for(i=0;i<exp.size();++i)
  //cout<<exp[i]<<" ";

  int error = 0;  
  this->tree = reTreeLabel(NULL,0,(int)exp.size()-1,exp, error);  
  infixSerie = createInfixSerie(this->tree);

  // cout<<"infix="<<infixSerie[0]<<endl;
  this->zero = false; 
} 


NodeTree* ExTreeLabel::reTreeLabel(NodeTree* p,int l,int r,
                       std::vector<string>& ex,int& error)
{
  int i=0;
  int prioIndex=0;
  int prio; 
  
  if(l>r) return NULL;

  if(r==l&&!isSymbol(ex[l][0])) 
    {
      if(ex[l]=="("||ex[l]==")") {error = 1;return NULL;} 
      NodeTree* tmp = new NodeTree(ex[l], false, NULL,NULL,p);
      return tmp;
    }

  if(r==l&&isSymbol(ex[l][0]) )
  { 
    error = 1;
    return NULL; 
  }  

  int unsigned nb=0; 
  i = r;
  if(ex[r]==")")
        { 
          nb = 1;
          while(i>=l&&nb>0) 
	    { --i;if(i<l) {error = 1;return NULL;} 
              if(ex[i]==")") ++nb; 
              if(ex[i]=="(") --nb; 
             
            }
          if(nb!=0) {error = 1;return NULL;}
          if(nb==0&&i<=l) 
            { 
              NodeTree* tmp = reTreeLabel(p,l+1,r-1,ex,error);
              if(error) return NULL;
              return tmp;
            }
        } 
 
  //find symbol with the smallest priority 
  prio = STAR_PRIORITY; 
  prioIndex = -1;
  i = r;
  nb=0;
  bool meet=false;

  while(i>=l)
    {

      if(ex[i]==")")
        { 
          nb = 1;
          while(i>=l&&nb>0) 
	    { i--; if(i<l) {error = 1;return NULL;}
              if(ex[i]==")") ++nb; 
              if(ex[i]=="(") --nb; 
            }
          if(nb!=0) {error = 1;return NULL;} 
        } 
      
      if(isSymbol(ex[i][0])) 
        { 
          if(!meet) { prioIndex = i; meet = true;}         
          if( getPrio(ex[i][0]) < (unsigned int)prio ) 
          {
            prio =  getPrio(ex[i][0]);prioIndex = i;
            if(ex[i][0]==COMPLEMENT&&i-1>=l)
               if(ex[i-1][0]==COMPLEMENT) prioIndex = i-1;
	  } 
	}
      --i;
    }

  if(prioIndex==-1) {error = 1;return NULL;} 

  //cout<<"\noper = "<<prioIndex<<endl<< flush;
  //cout << "\nl= "<<l<<", r= "<<r<<endl<< flush;
 
  NodeTree* tmp = new NodeTree(ex[prioIndex], true, NULL,NULL,p);
  tmp->left =reTreeLabel(tmp,l,prioIndex - 1,ex,error);
  if(error) return NULL; 

  if((ex[prioIndex][0]==ADDITION||ex[prioIndex][0]==PRODUCT||
      ex[prioIndex][0]==SUBTRACTION||ex[prioIndex][0]==INTERSECTION)
      &&tmp->left==NULL)
    {error=1;return NULL;}

  tmp->right=reTreeLabel(tmp,prioIndex + 1,r,ex,error);
  if(error) return NULL;
  if((ex[prioIndex][0]==ADDITION||ex[prioIndex][0]==PRODUCT||
      ex[prioIndex][0]==SUBTRACTION||ex[prioIndex][0]==INTERSECTION)
      &&tmp->right==NULL)
    {error=1;return NULL;} 
  return tmp;
}

std::vector<string> ExTreeLabel::getAlpha(void)
{
  return alphaSet;
}

//empty word is alpha[0]
int ExTreeLabel::test(std::vector<string>& ex, std::vector<string>& alpha, 
                    bool skip=false)
{
  if(ex.size()<=0) return 1;
  unsigned int i,j;
  unsigned int size=ex.size();
  std::vector<string> exp =std::vector<string>(size);
  unsigned int sizeEx=exp.size();
  
  //add operator "/"
  j=0;
  for(i=0;i<size;++i)
  { 
   if(ex[i][0]==STAR && i+1<size)
    if(!isSymbol(ex[i+1][0])&&ex[i+1]!=")") 
      { exp.resize(++sizeEx);  
        exp[j++] = ex[i]; 
        exp[j++] = "/";
        continue;}  
   if(ex[i][0]==STAR && i+1<size)
    if(ex[i+1][0]==COMPLEMENT) 
      { exp.resize(++sizeEx);  
        exp[j++] = ex[i]; 
        exp[j++] = "/";
        continue;}  

   if(ex[i]==")"&&i+1<size)
        if(!isSymbol(ex[i+1][0])&&ex[i+1]!=")")
      { exp.resize(++sizeEx); 
        exp[j++] = ex[i]; 
        exp[j++] = "/"; 
        continue;}   
   if(!isSymbol(ex[i][0])&&i+1<size&&ex[i]!="("&&ex[i]!=")" )
        if(!isSymbol(ex[i+1][0])&&ex[i+1]!=")" )
      { exp.resize(++sizeEx);  
        exp[j++] = ex[i]; 
        exp[j++] = "/";  
        continue;} 
   if(!isSymbol(ex[i][0])&&i+1<size&&ex[i]!="(")
        if(ex[i+1][0]==COMPLEMENT)
      { exp.resize(++sizeEx);
        exp[j++] = ex[i];  
        exp[j++] = "/";  
        continue;}  

   exp[j++] = ex[i];    
  }

  if(!skip)                      
  for(int unsigned j=0;j<exp.size();++j)
    {
      if(exp[j]!=")"&&exp[j]!="("&&(!isSymbol(exp[j][0])))
      if(find(alpha.begin(),alpha.end(),exp[j])==alpha.end()) return -1;
    }
  
  int error = 0;
  ExTreeLabel dummy = ExTreeLabel(alpha); 
  NodeTree* tree  = dummy.reTreeLabel(NULL,0,(int)exp.size()-1,exp, error);
  delete(tree);

  if(error!=0) return -1;
  else return 1; 
  return 1;  //good
}

void ExTreeLabel::deleteSubInter(NodeTree*& t)
{
   NodeTree *iNode,*jNode,*l,*r,*p;   
   string comp="";comp=comp+COMPLEMENT;
   string addi="";addi=addi+ADDITION;

   if(t!=NULL)
   {   
      deleteSubInter(t->left);
      deleteSubInter(t->right); 
      if(isSymbol(t->symbolS[0])) 
        { 
          if(t->symbolS[0]==SUBTRACTION)
          {
             t->symbolS = comp;
             l = new NodeTree(comp, true,NULL,t->left,NULL);
             if(t->left!=NULL) t->left->parent = l; 
             iNode = new NodeTree(addi, true,l,t->right,t);
             l->parent = iNode;
             if(t->right!=NULL) t->right->parent = iNode; 
             t->right = iNode;
             t->left=NULL;
          }
          else if(t->symbolS[0]==INTERSECTION)
          {
             t->symbolS = comp;
             l = new NodeTree(comp, true,NULL,t->left,NULL);
             if(t->left!=NULL) t->left->parent = l; 
             r = new NodeTree(comp, true,NULL,t->right,NULL);
             if(t->right!=NULL) t->right->parent = r; 
             iNode = new NodeTree(addi, true,l,r,t);
             l->parent = iNode;
             r->parent = iNode;
             t->right = iNode;
             t->left=NULL;
          } 
        }  
   } 
}

TreeLabel ExTreeLabel::toTreeLabel(std::vector<string>& alpha)
{ 
    std::vector<string> exp;
    NodeTree* tmp=this->copyTree(this->tree,NULL);
    deleteSubInter(tmp); 
    reToTreeLabel(tmp,alpha);

    TreeLabel lb;
    if(tmp==NULL) { lb = TreeLabel(true); return lb;}
    lb.setTree(tmp);   
    exp = lb.createInfixSerie(tmp);
    lb.setInfixSerie(exp);
    return lb;
}

void ExTreeLabel::reToTreeLabel(NodeTree*& t,std::vector<string>& alpha)
{
  if(t!=NULL)
  {  
    reToTreeLabel(t->left,alpha);
    if(t->left==NULL)
    {
      if(isSymbol(t->symbolS[0]))
      {
        switch(t->symbolS[0])
	  {
            case PRODUCT:
	    case STAR:
	      {delTree(t->right);delete(t);t=NULL;return;
               break;
              }
   	    case ADDITION:
              { // t->right <> NULL
                NodeTree* p;
                t->symbolS = t->right->symbolS;
                p = t->right;
                t->left = p->left;t->right = p->right;
                if(p->left!=NULL)  p->left->parent=t; 
                if(p->right!=NULL) p->right->parent=t; 
                delete(p); 
                return;
                break;
              } 
	  }
      }
    }
    else if(isEmptyWord(t->left->symbolS))
      {
        switch(t->symbolS[0])
	  {
            case PRODUCT:
              { // t->right <> NULL
                NodeTree* p,*q;
                t->symbolS = t->right->symbolS;
                p = t->right;q = t->left; 
                t->left = p->left;t->right = p->right;
                if(p->left!=NULL)  p->left->parent=t; 
                if(p->right!=NULL) p->right->parent=t; 
                delete(p);delete(q); 
                return;
                break;
              }     
            case STAR:
	      {
                NodeTree* p;
                t->symbolS = t->left->symbolS;
                p = t->left;t->left=NULL;
                delete(p);
                return;
                break;
	      }
	  }
      }

    reToTreeLabel(t->right,alpha);
    if(t->right==NULL)
    {
      if(isSymbol(t->symbolS[0])) 
      {
        switch(t->symbolS[0])
	  {
            case PRODUCT: 
              {delTree(t->left);delete(t);t=NULL;return;
               break;}
   	    case ADDITION:
              { //t->left <> NULL
                NodeTree* p;
                t->symbolS = t->left->symbolS;
                p = t->left;
                t->left = p->left;t->right = p->right;
                if(p->left!=NULL) p->left->parent=t; 
                if(p->right!=NULL)  p->right->parent=t;
                delete(p);
                return;
                break;
              }
	  }
        }
    } 
    else if(isEmptyWord(t->right->symbolS))
      {
        switch(t->symbolS[0])
	  {
            case PRODUCT:
              { // t->right <> NULL
                NodeTree* p,*q;
                t->symbolS = t->left->symbolS;
                p = t->right;q = t->left; 
                t->left = q->left;t->right = q->right;
                if(q->left!=NULL)  q->left->parent=t; 
                if(q->right!=NULL) q->right->parent=t; 
                delete(p);delete(q); 
                return;
                break;
              }     
	  }
      }

    if(isSymbol(t->symbolS[0]))
      {
       if(t->symbolS[0]==COMPLEMENT)
         {
           NodeTree* p=NULL,*q=NULL;
           NodeTree* l=NULL,*r=NULL,*i=NULL;
           TreeLabel lb;
           std::vector<string> exp,infix;
           Automata<TreeLabel>* auto2=NULL;
           if(t->right!=NULL)
	     {
              p  = this->copyTree(t->right,NULL);
              lb = TreeLabel(getEmptyWord()[0]);
              lb.setTree(p);   
              exp = lb.createInfixSerie(p);
              lb.setInfixSerie(exp);
	   
              //cout<<"\nExp1= "<<flush;
              //for(int unsigned i=0;i<exp.size();++i)
              //cout<<exp[i];

              Automata<TreeLabel>* auto1=lb.expToAuto("exp",alpha);
        
              Automata<TreeLabel>* auto3 = auto1->delAllSpon("spontaneous");
              delete(auto1);
         
              auto2=auto3->directComp("comp",alpha); 
	     
              //cout<<"\ncomplement="<<endl;
              //auto2->display(0);
              delete(auto3);
              GeneralAuto<TreeLabel> tmpC= GeneralAuto<TreeLabel>(*auto2);
              delete(auto2);
              tmpC.language(infix);
              if(infix.size()==0) 
	        {delTree(t);t=NULL;return;} // zero
              lb = TreeLabel(infix,getEmptyWord()[0]); 
	     }
           else
	     {
	      //cout<<"\nExp1= zero"<<flush;
              // ~0 = ~1 + 1
              lb = TreeLabel(getEmptyWord()[0]);
              Automata<TreeLabel>* auto3 = lb.expToAuto("exp",alpha);
              auto2=auto3->directComp("comp",alpha,true);
              delete(auto3);
              GeneralAuto<TreeLabel> tmpC= GeneralAuto<TreeLabel>(*auto2);
              delete(auto2);
              tmpC.language(infix);
              if(infix.size()==0) 
	        {delTree(t);t=NULL;return;} // zero
              lb = TreeLabel(infix,getEmptyWord()[0]);
              TreeLabel em = TreeLabel(getEmptyWord()[0]);
              lb = lb + em;  
	     }
        
           //lb.print();

           //cout<<"\nExp2= "<<flush;
           //exp = lb.getInfixSerie();
           //for(int unsigned i=0;i<exp.size();++i)
           //cout<<exp[i];

           q = lb.getTree();  
           lb.setTree(NULL);                 
           t->symbolS = q->symbolS;
           l = t->left;
           t->left  = q->left;
           if(t->left!=NULL) t->left->parent  = t;
           r = t->right;
           t->right = q->right;
           if(t->right!=NULL) t->right->parent = t;

           delTree(l);
           delTree(r);
           delete(q);
         } 
      }
  }
}

/*********************************************************************/
/*                     methodes of GeneralAuto                       */
/*********************************************************************/

template<class T>
GeneralAuto<T>::GeneralAuto(string name, int noOfStates, 
std::vector<string> alpha):Automata<T>(name,noOfStates,alpha)
{
    this->additionTrans();
}


template<class T>
GeneralAuto<T>::GeneralAuto(const Automata<string>& auto1):
                Automata<T>(auto1.getName())
{
    std::list<NameHist> l1 = auto1.getNameHists();
    std::list<NameHist>::iterator i1;
    std::list<OrgDstLabel<string> > l2 = auto1.getOrgDstLabels();
    std::list<OrgDstLabel<string> >::iterator i2;

    for(i1=l1.begin();i1!=l1.end();++i1)
       this->addState(i1->name,i1->hists);
 
    std::list<Transition<string> >::const_iterator iT;

    for(i2=l2.begin();i2!=l2.end();++i2)
      {
        T tmp = T(i2->lab); 
	this->addTransition(i2->org,i2->dst, tmp);
      }
    // simplify the transitions
    
    this->additionTrans();
   
    this->setHistType(auto1.getHistType()); 
    this->setDetermFlag(auto1.getDetermFlag());
    this->setCodetermFlag(auto1.getCodetermFlag());
    this->setAmbiguousFlag(auto1.getAmbiguousFlag()); 
    this->setCompleteFlag(auto1.getCompleteFlag());
    this->setNormalFlag(auto1.getNormalFlag());
    this->setHistOfITGraph(auto1.getHistOfITGraph());
    this->setNoInitStates();
    this->setNoTermStates(); 
}

template<class T>
GeneralAuto<T>::GeneralAuto(const Automata<T>& auto1):
Automata<T>(auto1.getName(),0,auto1.getAlphaSet())
{
    this->Automata<T>::reproduct(auto1);
    this->additionTrans();
}

template<class T>
GeneralAuto<T>::GeneralAuto(const GeneralAuto<T>& auto1):
Automata<T>(auto1.getName(),0,auto1.getAlphaSet()) 
{
   this->Automata<T>::reproduct(auto1);
}

//this method run only well with general automaton that
//is simplified !
template<class T>
void GeneralAuto<T>::additionTrans(void)
{ 
  std::list<std::list<Transition<T> >::iterator> l1 = this->getTransIters();
  
  std::list<std::list<Transition<T> >::iterator>::iterator  i1;
  
  i1 = l1.begin();
  do
   {  
    while(i1!=l1.end()) 
      { 
        std::list<T> l2 = this->searchTransByOrgDst((*i1)->getOrgPtr(),
                                                    (*i1)->getDstPtr());
        if(l2.size() > 1) 
          {
	    std::list<State<T> >::iterator s1 = (*i1)->getOrgPtr();
            std::list<State<T> >::iterator s2 = (*i1)->getDstPtr();
            std::list<T>::iterator i;
            T ex = T(this->getEmptyWord()[0]);
            i=l2.begin();     

            for(i=l2.begin();i!=l2.end();++i)
	      { 
                T lab = *i;
               
                if(ex.empty()) ex = lab; // empty word
                else 
                  {
                    ex = ex + lab;
		  }
                this->deleteTransition(s1->getName(), s2->getName(),*i);
              }
            this->addTransition(s1,s2,ex);
            
            l1 = this->getTransIters();
            i1 = l1.begin();
            break;
          }
        ++i1;
      }
   }while(i1!=l1.end());  
}

//this function is used for simplify the transitions that have 
//the same states   
template<class T>
void GeneralAuto<T>::additionTrans(std::list<State<T> >::iterator org,
                                   std::list<State<T> >::iterator dst)
{ 
  std::list<MetaNode<T> > exits = org->getAllExits();
  std::list<MetaNode<T> >::iterator iE;

  NodeTree* sum=NULL;
  NodeTree* t=NULL;
 
  for(iE=exits.begin();iE!=exits.end();++iE)
      if(iE->getTransPtr()->getDstPtr()==dst)
	{        
          if(sum==NULL) 
            {
              if(iE->getTransPtr()->empty())
		{
                   sum = new NodeTree(getEmptyWord(), false,NULL,NULL,NULL);
		}
              else
                { 
                   sum = iE->getTransPtr()->getLabelPointer();
                   iE->getTransPtr()->setLabelPointer(NULL);
		} 
	    }
          else
	    {
              if(iE->getTransPtr()->empty()&&sum->symbolS==getEmptyWord()) 
                 continue;
              else if(iE->getTransPtr()->empty())
		{
                   t = new NodeTree(getEmptyWord(), false,NULL,NULL,NULL);
		}
              else 
		{
                   t =  iE->getTransPtr()->getLabelPointer(); 
                   iE->getTransPtr()->setLabelPointer(NULL);
		} 
              NodeTree* x = new NodeTree("+", true, sum, t,NULL);
               
              sum->parent = x;
              t->parent   = x;
              sum = x;
	    }
	}

 
  std::list<MetaNode<T> > l1;
  while(true)
    {
      exits = org->getAllExits();
      for(iE=exits.begin();iE!=exits.end();++iE)
          if(iE->getTransPtr()->getDstPtr()==dst)
	    {
               this->deleteTransition(org,dst);
               break;
	    }
      if(iE==exits.end()) break;  
    }

  //TreeLabel dummy =TreeLabel(); 
  //std::vector<string> xx;  

  //cout<<"\n sum=  ";
  //xx = dummy.createInfixSerie(sum);
  //for(int unsigned i=0;i<xx.size();++i)
  //	   cout<<xx[i]<<" ";
  //cout<<endl;

  this->addTransition(org,dst,sum, getEmptyWord(),true);
  
}

template<class T>
bool GeneralAuto<T>::deleteState(std::string name)
{
  std::list<State<T> >::iterator i = this->searchStateByName(name);
  if(this->isLastState(i)) return false;
  else
    {
      deleteState(i);
      this->setNoInitStates();
      this->setNoTermStates();
      return true;  
    }
}

template<class T>
void GeneralAuto<T>::deleteState(std::list<State<T> >::iterator i)
{
  NodeTree *startLab=NULL;
  NodeTree *ex=NULL;

  std::list<QuadreX<T> > tuples;
  std::list<QuadreX<T> >::iterator it;
  
  /***************************************************************/

  bool flag = false;
  std::list<MetaNode<T> > listEx = i->getAllExits();
  std::list<MetaNode<T> >::iterator iEx;
  
  std::list<MetaNode<T> > listEn = i->getAllEntrances();
  std::list<MetaNode<T> >::iterator iEn;
  bool sw = false;
  for(iEn=listEn.begin();iEn!=listEn.end();++iEn)
    { 
     for(iEx=listEx.begin();iEx!=listEx.end();++iEx)
       {
          if(iEn->getTransPtr()->getOrgPtr()==i&&
             iEx->getTransPtr()->getDstPtr()==i)
           {
            
              startLab = iEn->getTransPtr()->getLabelPointer();
              iEn->getTransPtr()->setLabelPointer(NULL);

              if(startLab==NULL) flag = false;
              else if(isEmptyWord(startLab->symbolS)) flag = false;
              else flag = true;

              std::list<Transition<T> >::iterator mark = iEn->getTransPtr();
             
              i->deleteEntrance(iEn->getTransPtr()); 

              i->deleteExit(iEx->getTransPtr());

              this->deleteTransition(mark);

              sw = true;
              break; // important !!! 
           }  
       }
      if(sw) break; 
    }

  //this->testMetaNodes();

  listEx = i->getAllExits();  
  listEn = i->getAllEntrances();
  TreeLabel dummy =TreeLabel();
  bool delRight = false;
  std::list<NodeTree*> lR;

  for(iEn=listEn.begin();iEn!=listEn.end();++iEn)
    { 
     NodeTree* left=NULL;
     bool leftPer;
     leftPer = iEn->getTransPtr()->empty();
     left = iEn->getTransPtr()->getLabelPointer();
    
     for(iEx=listEx.begin();iEx!=listEx.end();++iEx)
       { 
         QuadreX<T> qu;   
         NodeTree* right=NULL; 
         bool rightPer;
         rightPer = iEx->getTransPtr()->empty();
         right = iEx->getTransPtr()->getLabelPointer();
         if(!delRight) lR.insert(lR.end(),right);

         if(flag)
	   {  
              qu.org   = iEn->getTransPtr()->getOrgPtr();
              qu.dst   = iEx->getTransPtr()->getDstPtr();  
              if(leftPer&&rightPer)
		{
                  NodeTree* star = dummy.copyTree(startLab,NULL);
                  NodeTree* s = new NodeTree("*", true, star, NULL ,NULL);
                  star->parent = s; 
                  qu.tree = s;
                  //cout<<"star="<<endl; 
		} 
              else if(leftPer) 
                { 
                 
                  NodeTree* star = dummy.copyTree(startLab,NULL);
                  NodeTree*  r   = dummy.copyTree(right,NULL);
                  NodeTree*  s = new NodeTree("*", true, star ,NULL ,NULL);
                  star->parent = s;
                  NodeTree* x = new NodeTree("/", true, s, r,NULL);
                  s->parent = x; 
                  if(r!=NULL) r->parent = x;
                  qu.tree = x; 
    
                  //cout<<"right="<<endl;
		}
              else if(rightPer) 
                { 
                 
                  NodeTree* star = dummy.copyTree(startLab,NULL);
                  NodeTree*  l   = dummy.copyTree(left,NULL);             
                  NodeTree* s = new NodeTree("*", true, star ,NULL ,NULL);
                  startLab->parent = s; 
                  NodeTree* y = new NodeTree("/", true, l ,s ,NULL);
                  s->parent = y; 
                  if(l!=NULL) l->parent = y;
                  qu.tree = y; 

                  //cout<<"left="<<endl;    
		}
              else
		{  
                  
                   NodeTree* star = dummy.copyTree(startLab,NULL);
                   NodeTree*  r   = dummy.copyTree(right,NULL);    
                   NodeTree*  l   = dummy.copyTree(left,NULL) ;   
                   NodeTree* s = new NodeTree("*", true, star,NULL ,NULL);
                   NodeTree* x = new NodeTree("/", true, s, r,NULL);
                   NodeTree* y = new NodeTree("/", true, l ,x ,NULL);
                   startLab->parent = s;
                   if(l!=NULL)  l->parent = y;
                   if(r!=NULL) r->parent = x;
                   x->parent = y;
                   s->parent = x;
                   qu.tree = y;
                   //cout<<"left+right="<<endl; 
                 }  
              //cout<<"OK2"<<endl<<flush;
	   }
         else
	   {
              qu.org   = iEn->getTransPtr()->getOrgPtr();
              qu.dst   = iEx->getTransPtr()->getDstPtr();
              if(leftPer&&rightPer)
		{
                  NodeTree* x = new NodeTree(getEmptyWord(), false, 
                                             NULL, NULL,NULL);
                  qu.tree = x; 
                  //cout<<"star2="<<endl;      
		}
              else if(leftPer) 
                { 
                  //iEx->getTransPtr()->setLabelPointer(NULL);
                  qu.tree  = dummy.copyTree(right,NULL);  
                  if(qu.tree!=NULL)  qu.tree->parent = NULL;
                  // cout<<"right2"<<endl; 
		}
              else if(rightPer) 
                {  
                  //iEn->getTransPtr()->setLabelPointer(NULL);
                  qu.tree =  dummy.copyTree(left,NULL); 
                  if(qu.tree!=NULL)  qu.tree->parent = NULL; 
                  //cout<<"left2"<<endl; 
		}
              else 
                {    
                  //iEn->getTransPtr()->setLabelPointer(NULL);
                  //iEx->getTransPtr()->setLabelPointer(NULL);
                  NodeTree*  r   = dummy.copyTree(right,NULL);    
                  NodeTree*  l   = dummy.copyTree(left,NULL) ;  
                  NodeTree* x = new NodeTree("/", true, l, r,NULL);
                  if(l!=NULL) l->parent = x;
                  if(r!=NULL) r->parent = x;
                  qu.tree = x; 

                  //cout<<"right2+left2"<<endl; 
	        }
              //cout<<"OK4"<<endl<<flush;
	   }
        
         tuples.insert(tuples.end(), qu); 
       }
       dummy.delTree(left);
       iEn->getTransPtr()->setLabelPointer(NULL);
       delRight = true;
    }

  dummy.delTree(startLab);
  for(std::list<NodeTree*>::iterator k=lR.begin();k!=lR.end();++k)
      dummy.delTree(*k);
  for(iEx=listEx.begin();iEx!=listEx.end();++iEx)
      iEx->getTransPtr()->setLabelPointer(NULL);  
  this->ITGraph<T>::deleteState(i); 


  /***************************************************************/

  //std::vector<string> xx;  
  //cout<<"\nTupes= "; 
  //for(it=tuples.begin();it!=tuples.end();++it)
  //  {         
  //    xx = dummy.createInfixSerie(it->tree);
  //    for(int unsigned i=0;i<xx.size();++i)
  //	   cout<<xx[i]<<" ";
  //   
  //  }
  // cout<<endl;

  if(tuples.empty()) return; 
  
  //cout<<"size tupes="<<tuples.size();
  
  //include to delete the element SELF (start) if exist 
  if(!flag) // there is not l'operation *
    {  //cout<<"\nNo star: "<< endl<<flush;
       std::list<QuadreX<T> >::iterator iq;
       for(iq=tuples.begin();iq!=tuples.end();++iq)
	 {  

            this->addTransition(iq->org,iq->dst,iq->tree,getEmptyWord(),true);
            this->additionTrans(iq->org,iq->dst); 
         }
    }
  else
    {  //cout<<"\nstar: "<< endl<<flush;
       std::list<QuadreX<T> >::iterator iq;
       for(iq=tuples.begin();iq!=tuples.end();++iq)
	 {  
         
            this->addTransition(iq->org,iq->dst,iq->tree,getEmptyWord(),true); 
            this->additionTrans(iq->org,iq->dst); 
         }

    }
  
   this->setNoInitStates();
   this->setNoTermStates();   
    
}

template<class T>
T GeneralAuto<T>::language(ListOfSymbols& order)
{
      T result(this->getEmptyWord()[0]);

      if((int)order.size()!=getNoStates()) return false;
      ListOfSymbols::iterator i = order.begin();  
      for(;i!=order.end();++i) 
	if(!deleteState(*i)) { T zero(true); return zero; } 

      std::list<MetaNode<T> > l = listOfStates.begin()->getAllExits();
    
      if(!l.empty()) 
        { 
           result = l.begin()->getTransPtr()->getLabel();
           std::vector<string> infix = result.createInfixSerie(result.getTree());
           //cout<<"\nInfix= ";
           //for(int unsigned k=0;k<infix.size();++k) cout<<infix[k]; 
           result.setInfixSerie(infix);
           return result;
        }
      else { result = T(true); return result; }
}

template<class T>
void GeneralAuto<T>::language(std::vector<string>& l)
{ 
  //cout<<"before lan= "<<endl<<flush;
  //display(0);  

  std::list<State<T> >::iterator i;
  while(true) 
      { 
         i = this->listOfStates.begin();++i;++i;
         if(i==listOfStates.end()) break;
         deleteState(i); 

         //cout<<"numStates= "<<this->getNoStates()<<endl<<flush;
         //cout<<"numTrans= "<<this->getNoTrans()<<endl<<flush;
      }
      
  std::list<MetaNode<T> > l1 = listOfStates.begin()->getAllExits(); 
  TreeLabel result;
 
  if(!l1.empty())
    {
      l = result.createInfixSerie(
          l1.begin()->getTransPtr()->getLabel().getTree());
      //It is possible to be empty !!!
    }
  else l.clear(); // l.size==0, zero language

  //result.delTree(l1.begin()->getTransPtr()->getLabel().getTree());
  //l1.begin()->getTransPtr()->setLabelPointer(NULL);
}

template<class T>
void GeneralAuto<T>::heapLanguage(std::vector<string>& l)
{ 
  std::list<State<T> >::iterator is,hi,iInit;
  std::vector<StateHeap<T> > stateVector;
  stateVector.resize(this->getNoStates()+2);
  Heap<T>  heap(this->getNoStates());
 
  int i=0;
  int pos=0;
  HeapNode ele;
  for(iInit=this->listOfStates.begin();iInit!=this->listOfStates.end();++iInit)
    {
      int numAn=0;
      int numSuc=0;

      if(i>1) iInit->setIdOfState(i);
      stateVector[i].iter = iInit;
      numAn  = this->getNumAncestors(iInit);
      numSuc = this->getNumSuccessors(iInit);
      stateVector[i].numAncestors  =  numAn;
      stateVector[i].numSuccessors =  numSuc;
      if(i>1) 
	{
         ele.index = i;
         ele.weight= numAn*numSuc; 
         heap.insert(ele,stateVector);
	}
      ++i;
    }

  std::vector<int> anSu;
  while(!heap.empty()) 
    { 
        
      HeapNode root;
      heap.remove(root,stateVector);
      
      anSu.clear();

      this->ancestors(stateVector[root.index].iter,anSu);
      this->successors(stateVector[root.index].iter,anSu); 

      cout<<"\nDeleting : "<<stateVector[root.index].iter->getName()
          <<endl<<flush;
      deleteState(stateVector[root.index].iter);
          
      //cout<<"\nDeleted : "<<endl<<flush;
      //cin.get();

      if(this->getNoStates()==0) break;

      for(int unsigned j=0;j<anSu.size();++j)
	{
           int an=0,su=0;
           if(anSu[j]==1||anSu[j]==0) continue;

           an = this->getNumAncestors(stateVector[anSu[j]].iter);
           su = this->getNumSuccessors(stateVector[anSu[j]].iter);
           //cout<<"OK21"<<endl<<flush;
           stateVector[anSu[j]].numAncestors  = an;
           stateVector[anSu[j]].numSuccessors = su; 
           
           if(heap.isUpdate(an*su ,stateVector[anSu[j]].indexHeap))
	     {
               
                heap.deleteD(stateVector[anSu[j]].indexHeap,stateVector);
                ele.index = anSu[j];
                ele.weight= an*su;
                heap.insert(ele,stateVector);           
	     } 
	}

      //cout<<"numStates= "<<this->getNoStates()<<endl<<flush;
      //cout<<"numTrans= "<<this->getNoTrans()<<endl<<flush;
    }
  std::list<MetaNode<T> > l1 = listOfStates.begin()->getAllExits(); 
  TreeLabel result;

  if(!l1.empty())
    {
      l = result.createInfixSerie(
          l1.begin()->getTransPtr()->getLabel().getTree());
    }
  else l.clear();

  //result.delTree(l1.begin()->getTransPtr()->getLabel().getTree());
  //l1.begin()->getTransPtr()->setLabelPointer(NULL);
}

template<class T>
void GeneralAuto<T>::ancestors(std::list<State<T> >::iterator i,std::vector<int>& index)
{ 
  std::list<MetaNode<T> > l = i->getAllEntrances();
  std::list<MetaNode<T> >::iterator k = l.begin();
  for(;k!=l.end();++k)
    {
     if(k->getTransPtr()->getOrgPtr()!=i)
       {
         int id =  k->getTransPtr()->getOrgPtr()->getIdOfState();
         if(id==-1) id = 1;
         index.insert(index.end(), id);
       }
    }
}

template<class T>
void GeneralAuto<T>::successors(std::list<State<T> >::iterator i,std::vector<int>& index)
{ 
  std::list<MetaNode<T> > l = i->getAllExits();
  std::list<MetaNode<T> >::iterator k = l.begin();
  for(;k!=l.end();++k)
    {
     if(k->getTransPtr()->getDstPtr()!=i)
       {
         int id =  k->getTransPtr()->getDstPtr()->getIdOfState();
         if(id==-1) id = 1;
         index.insert(index.end(), id);
       }
    }
}

template<class T>
int GeneralAuto<T>::getNumAncestors(std::list<State<T> >::iterator i)
{
  std::list<MetaNode<T> > l = i->getAllEntrances();
  return (int)l.size();
}

template<class T>
int GeneralAuto<T>::getNumSuccessors(std::list<State<T> >::iterator i)
{
  std::list<MetaNode<T> > l = i->getAllExits();
  return (int)l.size();
}






