
//#include "Headers.h"

/* ************************************** */
/* *  All of declarations               * */
/* ************************************** */

template<class T> 
Interface<T>::Interface() { }

template<class T> 
Automata<T>* Interface<T>::createAutomata(string name)
  {
  unsigned int numS;
  int numLetter;
  int unsigned i;
  string numInput;
  const char* numStr;
  string choice;
  string trans;
  string org,dst;
  string label;
  string stateName;
  int unsigned zzz;
  std::vector<string> alpha;   
  string emptyWord;
  do
  {
    cout << "Enter number of States : ? " << flush;
    cin >> numInput; numStr = numInput.c_str();
    if( (numS=atoi(numStr)) > 0) break;
  }while(true); 
  
  Automata<T>* autoT = new Automata<T>(name,numS,alpha);

  do
    { 
       cout << "Do you want to rename states (y,n) ? " << flush;
       cin >> choice;
    }
  while(choice!="n"&&choice!="N"&&choice!="y"&&choice!="Y");
  std::vector<string> strsS; strsS.resize(numS);

  if(choice=="y"||choice=="Y")
    {
      string name;
      cout << "Enter names of states (whitespace-separated) ? : " << endl << flush;
      cin.get();
      readStrings(strsS, name);      
      autoT->renameStates(strsS);
    
      cout << "Names of states : " << flush;
      for(i=0;i<strsS.size();++i) cout << strsS[i] << " " << flush;
    }
    else
    {
      cout << "Names of states : " << flush;
      for(i=0;i<numS;++i) 
       {
         strsS[i] = Interface<TreeLabel>::intToString(i+1); 
         cout << i+1 << " " << flush;
       }
    }
  
  do
  {
    cout << "\nEnter number of characters : ? " << flush;
    cin >> numInput; numStr = numInput.c_str();
    if((numLetter=atoi(numStr))>0) break;
    
  }while(true); 

  do
    { 
       cout << "Do you want to rename characters (y,n) ? " << flush;
       cin >> choice; cin.get();
    }
  while(choice!="n"&&choice!="N"&&choice!="y"&&choice!="Y");

  alpha.resize(numLetter+1);
  string name1;

  if(choice=="y"||choice=="Y")
    {
      int c=0;
      std::vector<string> strs; strs.resize(numLetter);
      
      do{
        cout << "Enter characters (whitespace-separated) ? : "<<endl;
        c = readStrings(strs,name1);
        if(c!=numLetter) 
	  {cout<<"Invalid letters !"<<endl;continue;}
        else break;
      }while(true); 

      bool unit = false;
      bool diese = false;  
      string emp="";emp=emp+EMPTY_WORD; 
      string sDiese="";sDiese=sDiese+DIESE;
      for(int i=0;i<numLetter;++i) 
         { 
           alpha[i+1] = strs[i];
           if(strs[i]==emp) unit=true;    
           if(strs[i]== sDiese) diese=true;
	 }  

      if(unit&&diese)
	{
          do{
	    cout<<"Enter the empty word ? : ";
            cin>>emptyWord;cin.get();
            if(emptyWord==emp||emptyWord==sDiese) continue;
            else break; 
          }while(true); 
          alpha[0] = emptyWord;
	}
      else if(unit) alpha[0] = sDiese;
      else alpha[0] = emp;
     
      autoT->setAlphaSet(alpha);
    }
  else
    {  
      if(numLetter<='z'-'a')
	 {
           string emp="";emp=emp+EMPTY_WORD; 
           alpha[0] = emp;
           char i;
           string s = "";
           for(i='a';i<'a'+numLetter;i++)
	   { s = "";
             alpha[i-'a'+1] = s + i;
	   }
           autoT->setAlphaSet(alpha);
	 }
      else
	{
           string s = "";
           string emp="";emp=emp+DIESE; 
           alpha[0] = emp;
           for(int i=1;i<=numLetter;i++)
	   { 
             alpha[i] = Interface<TreeLabel>::intToString(i);
	   }
           autoT->setAlphaSet(alpha);
	}
    }
  cout << "\nCharacters : ";
  cout<<"("<<alpha[0]<<") ";
  for(int iC=1;iC<=numLetter;++iC) cout<<alpha[iC]<<" ";
  cout<<endl;

  // enter initial states 
  int unsigned numI = numS;
 
  string dummy;  
  std::vector<string> strsI; strsI.resize(numI);
  strsI.resize(numI);

  do
  {
   cout << "\nNames of initial states (whitespace-separated) ? : "<<endl;
   numI = readStrings(strsI,dummy);
   //numI = (numS < numI) ? numS : numI;      
 
   for(i=0;i<(int unsigned)numI;++i)
     {
       if(find(strsS.begin(),strsS.end(),strsI[i])==strsS.end())
         {
	   cout << "\nError, the state "<<strsI[i]<<" isn't exist !"<<endl;
           break;
         }
       else
         { 
           autoT->setInitialState(strsI[i],alpha[0][0]);    
           //cout <<"\nAfter: "<< lab << endl << flush;  
         }
     }
   if(i==(int unsigned)numI) break;
   else continue;
  }while(true);

  strsI.resize(numS);

  do
  {
   cout << "Names of terminal states (whitespace-separated) ? : "<<endl;
   numI = readStrings(strsI,dummy);      
   //numI = (numS < numI) ? numS : numI;
  
   for(i=0;i<(int unsigned)numI;++i)
     {
       if(find(strsS.begin(),strsS.end(),strsI[i])==strsS.end())
        {
          cout << "\nError, the state "<<strsI[i]<<" isn't exist !"<<endl;
          break;
        }
       else
          autoT->setTerminalState(strsI[i],alpha[0][0]);          
     }
   if(i==(int unsigned)numI) break;
   else continue;
  }while(true);

  int unsigned j =0,k=0;
  cout<<"\nEnter the transitions: "<< endl << flush; 
  for(i=1;i<alpha.size();++i)
    {         
	cout<<"Transitions labeled by ["<<alpha[i]<<"] coming "<<endl;
        for(j=0;j<strsS.size();++j)
	  {
            cout << "From " <<strsS[j]<< " to ? : ";     
            numI = readStrings(strsI,dummy);
            for(k=0;k<numI;++k)
	      {
                 if(find(strsS.begin(),strsS.end(),strsI[k])==strsS.end() ) 
                 {
                   cout << "State "<<strsI[k]<<" isn't exist !"<<endl; 
                   --j; break; 
                 }
		 std::vector<string> exp;
                 exp.insert(exp.end(),alpha[i]);
                 T lab = T(exp,alpha[0][0]);
                 autoT->addTransition(strsS[j],strsI[k],lab); 
                 
              }
          }
    }
  
  //autoT->display(0); 
  
  autoT->setNoInitStates();
  autoT->setNoTermStates();
  return autoT;
}

template<class T> 
GeneralAuto<T>* Interface<T>::createGeneralAuto(string name)
{
  Automata<T>*  auto1 = Interface<T>::createAutomata(name);
  GeneralAuto<T>* gen = new GeneralAuto<T>(*auto1);
  return gen;
}

template<class T> 
Transducer<T>* Interface<T>::createTransducer(string name)
  {
  unsigned int numS;
  int numInLetter;
  int numOutLetter;
  int unsigned i;
  string numInput;
  const char* numStr;
  string choice;
  string org,dst;
  std::vector<string> outAlpha;
  std::vector<string> inAlpha;
  string stateName;
  string emptyWord;  
  string dummy;
  int type = 0;
  do
    { 
       cout<<"1) Transducer LetterToLetter."<<endl;
       cout<<"2) Transducer LetterToEx."<<endl;
       cout<<"3) Transducer WordToEx."<<endl;

       cout << "Select a number ? ";
       cin >> choice; cin.get();
    }
  while(choice!="1"&&choice!="2"&&choice!="3");
  type = atoi(choice.c_str());
 
  do
  {
    cout << "Enter number of states : ? " << flush;
    cin >> numInput; cin.get();
     numStr = numInput.c_str();
    if( (numS=atoi(numStr)) > 0) break;
  }while(true); 
  
  Transducer<T>* transT=NULL;
  std::vector<string> exp;
  switch(type)
    {
      case 1:  {  transT = new LTOLTransducer<T>(name,numS,exp,exp);break;}
      case 2:  {  transT = new LTOEXPTransducer<T>(name,numS,exp,exp);break;}
      case 3:  {  transT = new WTOEXPTransducer<T>(name,numS,exp,exp);break;}
      default: {  return NULL;}
    }

  do
    { 
       cout << "Do you want to rename states (y,n) ? ";
       cin >> choice; cin.get();
    }
  while(choice!="n"&&choice!="N"&&choice!="y"&&choice!="Y");
  std::vector<string> strsS; strsS.resize(numS);

  if(choice=="y"||choice=="Y")
    {
      string name;
      cout << "Enter names of states (whitespace-separated) ? :"<<endl;
      readStrings(strsS, name);      
      transT->renameStates(strsS);
      cout << "Names of states : ";
      for(i=0;i<strsS.size();++i) cout << strsS[i] <<" ";
    }
    else
    {
      cout << "Names of states : ";
      for(i=0;i<numS;++i) 
       {
         strsS[i] = transT->intToString(i+1); 
         cout << i+1 << " ";
       }
    }
 
  do
  {
    cout << "\nEnter number of input characters : ? ";
    cin >> numInput; cin.get();
    numStr = numInput.c_str();
    if( (numInLetter=atoi(numStr)) > 0) break;
  }while(true); 

  do
    { 
       cout << "Do you want to rename characters (y,n) ? " << flush;
       cin >> choice;cin.get();
    }
  while(choice!="n"&&choice!="N"&&choice!="y"&&choice!="Y");
  
  inAlpha.resize(numInLetter+1); 
  if(choice=="y"||choice=="Y")
    {
      int c=0;
      std::vector<string> strs; strs.resize(numInLetter);
    
      do{
         cout << "Enter characters (whitespace-separated) ? : "<<endl;
         c = readStrings(strs,dummy);
        if(c!=numInLetter) 
	  {cout<<"Invalid letters !"<<endl;continue;}
        else break;
      }while(true); 

      bool unit = false;
      bool diese = false;  
      string emp="";emp=emp+EMPTY_WORD; 
      string sDiese="";sDiese=sDiese+DIESE;
      for(int i=0;i<numInLetter;++i) 
         { 
           inAlpha[i+1] = strs[i];
           if(strs[i]==emp) unit=true;    
           if(strs[i]== sDiese) diese=true;
	 }  

      if(unit&&diese)
	{
          do{
	    cout<<"Enter the empty word ? : ";
            cin>>emptyWord;cin.get();
            if(emptyWord==emp||emptyWord==sDiese) continue;
            else break; 
          }while(true); 
          inAlpha[0] = emptyWord;
	}
      else if(unit) inAlpha[0] = sDiese;
      else inAlpha[0] = emp;     
      transT->setInputAlpha(inAlpha);
    }
  else
    {
      if(numInLetter<='z'-'a')
	 {
           string emp="";emp=emp+EMPTY_WORD; 
           inAlpha[0] = emp;
           char i;
           string s = "";
           for(i='a';i<'a'+numInLetter;i++)
	   { s = "";
             inAlpha[i-'a'+1] = s + i;
	   }
           transT->setInputAlpha(inAlpha);
	 }
      else
	{
           string s = "";
           string emp="";emp=emp+DIESE; 
           inAlpha[0] = emp;
           for(int i=1;i<=numInLetter;i++)
	   { 
             inAlpha[i] = Interface<TreeLabel>::intToString(i);
	   }
           transT->setInputAlpha(inAlpha);
	}
      
    }
  cout << "\nCharacters : "; 
  cout<<"("<<inAlpha[0]<<") ";
  for(int unsigned iChar=1;iChar<inAlpha.size();++iChar)
    cout << inAlpha[iChar] <<" ";
 
  string numOutput;
  do
  {
    cout << "\nEnter number of output characters : ? ";
    cin >> numOutput;cin.get(); numStr = numOutput.c_str();
    if( (numOutLetter=atoi(numStr)) > 0) break;
  }while(true); 

  do
    { 
       cout << "Do you want to rename characters (y,n) ? " << flush;
       cin >> choice;cin.get();
    }
  while(choice!="n"&&choice!="N"&&choice!="y"&&choice!="Y");

  outAlpha.resize(numOutLetter+1); 
 
  if(choice=="y"||choice=="Y")
    {
      int c=0;
      std::vector<string> strs; strs.resize(numOutLetter);
    
      do{
         cout << "Enter characters (whitespace-separated) ? : "<<endl;
         c = readStrings(strs,dummy);
        if(c!=numOutLetter) 
	  {cout<<"Invalid letters !"<<endl;continue;}
        else break;
      }while(true); 

      bool unit = false;
      bool diese = false;  
      string emp="";emp=emp+EMPTY_WORD; 
      string sDiese="";sDiese=sDiese+DIESE;
      for(int i=0;i<numOutLetter;++i) 
         { 
           outAlpha[i+1] = strs[i];
           if(strs[i]==emp) unit=true;    
           if(strs[i]== sDiese) diese=true;
	 }  

      if(unit&&diese)
	{
          do{
	    cout<<"Enter the empty word ? : ";
            cin>>emptyWord;cin.get();
            if(emptyWord==emp||emptyWord==sDiese) continue;
            else break; 
          }while(true); 
          outAlpha[0] = emptyWord;
	}
      else if(unit) outAlpha[0] = sDiese;
      else outAlpha[0] = emp;     
      transT->setOutputAlpha(outAlpha);
    }
    else
    {
      if(numOutLetter<='z'-'a')
	 {
           string emp="";emp=emp+EMPTY_WORD; 
           outAlpha[0] = emp;
           char i;
           string s = "";
           for(i='a';i<'a'+numOutLetter;i++)
	   { s = "";
             outAlpha[i-'a'+1] = s + i;
	   }
           transT->setOutputAlpha(outAlpha);
	 }
      else
	{
           string s = "";
           string emp="";emp=emp+DIESE; 
           outAlpha[0] = emp;
           for(int i=1;i<=numOutLetter;i++)
	   { 
             outAlpha[i] = Interface<TreeLabel>::intToString(i);
	   }
           transT->setOutputAlpha(outAlpha);
	}
      
    }

  cout << "\nCharacters : "; 
  cout<<"("<<outAlpha[0]<<") ";
  for(int unsigned iChar=1;iChar<outAlpha.size();++iChar)
    cout << outAlpha[iChar] <<" ";

  // enter initial states
  cout << "\nEnter names of initial states and labels :"<<endl; 
  int unsigned numI = numS;//numS = number of states
  
  if(numI<2) numI=2;// 2 =  1(state)+ 1(input) 
  std::vector<string> strsI; strsI.resize(numI);
  strsI.resize(numI);
  std::vector<string> expOut;
  do
  { 
   expOut.clear();  
   //this moment, an expression input is string !!!!
   //but his representation is a vector !!! 
   //Function "readStateWithLabel" hide the mean of input !!!
   cout<<"[state input / output] : ";
   int numI = readStateWithLabel(strsI,expOut,inAlpha);
   if(numI==0) break;
   if(numI==-1) {cout<<"Invalid data !"<<endl;continue;}
   if(numI>4) { cout<<"Too many parameters !"<<endl; continue;} 
   if(strsI[1]==""||expOut.empty()) 
     {
       cout<<"Invalid data : input or output !"<<endl;continue; 
     }
       
   TreeLabel output;
   //empty word of input == "" !!!
   if(transT->isInputEmptyWord(strsI[1])) strsI[1] = ""; 
   // the value of empty word
   if(expOut.size()==1&&transT->isOutputEmptyWord(expOut[0]))
       output = TreeLabel(outAlpha[0][0]);
   else
     {   
       if(TreeLabel::test(expOut,outAlpha)!=1) 
         { cout<<"Syntax error !"<<endl; continue; }
       output = TreeLabel(expOut,outAlpha[0][0]);   
     }   
   
   if(find(strsS.begin(),strsS.end(),strsI[0])==strsS.end())
         {
	   cout << "\nError, the state "<<strsI[0]<<" isn't exist !"<<endl;
           continue;
         }
   else
         { 
           transT->setOnInitialState(strsI[0],strsI[1],output);  
         }
 
  }while(true);

  // enter terminal states
  cout << "\nEnter names of terminal states and labels :"<<endl; 
  if(numI<2) numI=2; strsI.resize(numI);
  //expOut.clear();
  do
  {
   expOut.clear();  
   cout<<"[state input / output] : ";
   int numI = readStateWithLabel(strsI,expOut,inAlpha);
   if(numI==0) break;
   if(numI==-1) {cout<<"Invalid data !"<<endl;continue;}
   if(numI>4) { cout<<"Too many parameters !"<<endl; continue;}
   if(strsI[1]==""||expOut.empty()) 
     {
       cout<<"Invalid data : input or output !"<<endl;continue; 
     }

   TreeLabel output; 
   if(transT->isInputEmptyWord(strsI[1])) strsI[1] = ""; 
   // the value of empty word
   if(expOut.size()==1&&transT->isOutputEmptyWord(expOut[0]))
       output = TreeLabel(outAlpha[0][0]);
   else
   {
        if(TreeLabel::test(expOut,outAlpha)!=1) 
           { cout<<"Syntax error !"<<endl; continue;}  
        output = TreeLabel(expOut,outAlpha[0][0]);
   }   
  
   if(find(strsS.begin(),strsS.end(), strsI[0])==strsS.end() )
         {
	   cout << "\nError, the state "<<strsI[0]<<" isn't exist !"<<endl;
           continue;
         }
   else
         { 
           transT->setOnTerminalState(strsI[0],strsI[1],output);   
         }
 
  }while(true);

  int unsigned j =0,k=0; 
  std::vector<string> trans;trans.resize(2);
  cout<<"\nEnter transitions: "<<endl;
  switch(type)
  {
  // for transducer: LTOL
  case 1:
  {
  for(i=1;i<inAlpha.size();++i)
  for(int unsigned i1=1;i1<outAlpha.size();++i1)
    {         
      cout<<"Transitions labeled by ["<<inAlpha[i]<<"/"<<outAlpha[i1]
          <<"] coming "<<endl;
        for(j=0;j<strsS.size();++j)
	  {
            cout << "From " <<strsS[j]<< " to ? : ";
            strsI.resize(numS);     
            numI = readStrings(strsI,dummy);
            for(k=0;k<numI;++k)
	      {
                 if(find(strsS.begin(),strsS.end(),strsI[k])==strsS.end() ) 
                 {
                   cout << "State "<<strsI[k]<<" isn't exist !" <<endl<< flush; 
                   --j; break; 
                 }
		 string input="";input = input + inAlpha[i];
                 std::vector<string> output;
                 output.insert(output.end(),outAlpha[i1]);
                 T lab =  T(input,TreeLabel(output, outAlpha[0][0])); 
                 transT->addTransition(strsS[j],strsI[k],lab);
              }
          }
    }    
    break;
  }//end of case 1
  // for transducer: LTOEXP
  case 2:
  {
  string input="";
  std::vector<string> outExp;
  for(i=1;i<inAlpha.size();++i)
    {
      
      input="";   
      outExp.clear();  
      do{         
      cout<<"Transitions labeled by input     = "<<inAlpha[i]<<endl;
      cout<<"                    by [/ output] = ? ";   
      numI = readLabel(input,outExp,inAlpha);
      if(numI==0) break;

      //input =="" because input = inAlpha[i] !!!
      if(numI!=2||input!="") {cout<<"Invalid output !"<<endl;continue;}
      
      if(outExp.empty()) 
      {
       cout<<"Invalid data : output !"<<endl;continue; 
      } 

      TreeLabel output;   
      if(expOut.size()==1&&transT->isOutputEmptyWord(outExp[0]))
         output = TreeLabel(outAlpha[0][0]);
      else
	{
          if(TreeLabel::test(outExp,outAlpha)!=1) 
             { cout<<"Syntax error !"<<endl; continue;}
          output = TreeLabel(outExp,outAlpha[0][0]); 
	}  
    
      cout<<"Transitions labeled by labeled ["<<inAlpha[i]<<"/"
          <<output<<"]"<<endl;
      for(j=0;j<strsS.size();++j)
	  {
            cout << "From " <<strsS[j]<< " to ? : ";     
            numI = readStrings(strsI,dummy);
            for(k=0;k<numI;++k)
	      {
                 if(find(strsS.begin(),strsS.end(),strsI[k])==strsS.end() ) 
                 {
                   cout << "State "<<strsI[k]<<" isn't exist !" <<endl<< flush; 
                   --j; break; 
                 }
                 input="";input = input + inAlpha[i];
                 T lab =  T(input,output); 
                 transT->addTransition(strsS[j],strsI[k],lab);
              }
          }
      }
      while(true);
    }    
    break;
  }//end of case 2
  // for transducer: WTOEXP
  case 3:
  { 
    string input="";
    if(numI<2) numI=2;
    strsI.resize(numI);
    std::vector<string> outExp;  
    do
    { 
      input="";   
      outExp.clear();  
      cout<<"Enter label(input / output) ? : ";
      numI = readLabel(input,outExp,inAlpha);
      if(numI==0) break;
      if(numI!=2) { cout<<"Invalid label !"<<endl;continue;} 

      if(input==""||outExp.empty()) 
      {
       cout<<"Invalid data : input or output !"<<endl;continue; 
      }

      if(transT->isInputEmptyWord(input)) input="";  
      TreeLabel output;   
      if(expOut.size()==1&&transT->isOutputEmptyWord(outExp[0]))
         output = TreeLabel(outAlpha[0][0]);
      else
	{
          if(TreeLabel::test(outExp,outAlpha)!=1) 
             { cout<<"Syntax error !"<<endl; continue;}
          output = TreeLabel(outExp,outAlpha[0][0]); 
	}  
            
      cout<<"Transitions labeled by ["<<input<<"/"<<
            output<<"] :"<<endl;
         
      do
          { 
            cout<<"[out in]: ";    
            numI = readStrings(trans,dummy);
            if(numI==0) break;  
            if(numI!=2) { cout<<"Invalid transition !"<<endl;continue;}
            //strS : set of states
            if(find(strsS.begin(),strsS.end(),trans[0])==strsS.end())
              {
                cout << "Error, the state "<<trans[0]<<" isn't exist !"<<endl;                 continue;
              }

            if(find(strsS.begin(),strsS.end(),trans[1])==strsS.end() )
              {
                cout << "Error, the state "<<trans[1]<<" isn't exist !"<<endl;                 continue;
              }

            T lab =  T(input,output);
            transT->addTransition(trans[0],trans[1],lab);
              
          }while(1);
      } while(1);
      break;
    }//end of case 3
  }//end of switch
    
  transT->setNoInitStates();
  transT->setNoTermStates();
  return transT;
}

template<class T> 
int Interface<T>::readStrings(std::vector<string>& v,string& s)
{
  unsigned int i = 0, n =0;
  
  string tmp,tmp1;
  std::getline(cin,tmp);
  while(tmp[i]==' '&& i<tmp.size()) i++; 
  if(i==tmp.size()) return n;
  v[n] = "";
  do{
     while(tmp[i]!=' '&& i<tmp.size()) { v[n] = v[n] + tmp[i];++i;}
     tmp1 = v[n];
     s = s + tmp1[0];
     ++n; 
     if(i < tmp.size()) 
       {  
         if(n>=v.size()) v.resize(n+1);
         v[n] ="";
         while(tmp[i]==' '&& i<tmp.size()) i++; 
         if(i==tmp.size()) return n;
       }
     else break;
  }while(true);

  return (int)n;

}

template<class T> 
int Interface<T>::readLabel(string& v,std::vector<string>& exp, 
                            std::vector<string>& alpha)
{
  string dummy;std::vector<string>::iterator start =  alpha.begin();
  std::vector<string> vv =std::vector<string>(3); 
  int n = readStrings(vv,dummy);
  if(n==0) return 0;
  if(n==1)
    { 
      if(vv[0]=="/") {v="";exp.clear();return 2;}// all are null
      else { 
             for(int unsigned i=0;i<vv[0].size();++i)
	       {
                 string tmp="";tmp=tmp+vv[0][i];
	         if(find(alpha.begin(),alpha.end(),tmp)==alpha.end()) 
                    {//cout<<"error 3"<<endl;
                     return -1;}
	       }
             v=vv[0];exp.clear();
             return 2;
           }
    } 

  if(vv[1]!="/")
    {
     if(vv[0]!="/") return -1;
     else 
       { 
         v="";
         strToExp(vv[1], exp);
         return 2;
       }
    }
  else
    {    
         for(int unsigned i=0;i<vv[0].size();++i)
            {
                 string tmp="";tmp=tmp+vv[0][i];
	         if(find(alpha.begin(),alpha.end(),tmp)==alpha.end())
                    {
                     //cout<<"error 3"<<endl;
                     return -1;}
	    }
	  
         v = vv[0];
         if(n==2) { exp.clear(); return 2;}
         strToExp(vv[2], exp);
         return 2;
     }
  return 2;
}

template<class T> 
int Interface<T>::readStateWithLabel(std::vector<string>& v,
                  std::vector<string>& exp, std::vector<string>& alpha)
{
  string dummy;std::vector<string>::iterator start =  alpha.begin();
  std::vector<string> vv =std::vector<string>(4); 
  int n = readStrings(vv,dummy);
  if(n==0) return 0;
  if(n==1)
    { 
      v[0]=vv[0];
      v[1]="";exp.clear();
      return 2;
    }
 
  v[0]=vv[0];
  if(n==2)
    {       
      if(vv[1]=="/") {v[1]="";exp.clear();return 2;}// all are null
      else { 
             for(int unsigned i=0;i<vv[1].size();++i)
	     {
                 string tmp="";tmp=tmp+vv[1][i];
	         if(find(alpha.begin(),alpha.end(),tmp)==alpha.end())
                    {
                     //cout<<"error 3"<<endl;
                     return -1;}
	     } 
             v[1]=vv[1];
             exp.clear();
             return 2;
           }
    }
  //n>2
  if(vv[2]!="/")
    {
     if(vv[1]!="/") return -1;
     else 
       { 
         v[1]="";
         strToExp(vv[2], exp);
         return 2;
       }
    }
  else
    {    
      for(int unsigned i=0;i<vv[1].size();++i)
	   {
               string tmp="";tmp=tmp+vv[1][i];
	       if(find(alpha.begin(),alpha.end(),tmp)==alpha.end())
                  {
                     //cout<<"error 3"<<endl;
                     return -1;}
	   } 
      v[1] = vv[1];
      if(n==3) { v[2]=""; return 2;}
      strToExp(vv[3], exp);
      return 2;
    }
  return 2;
}

template<class T>
string Interface<T>::intToString(int i)
{
  string result="";
  char   media;  

  if(i==0) 
  { 
    media =  48;
    result = result+media;
    return result;
  }
 
  while(i!=0) 
  {
    media = (i % 10) + '0';
    string tmp = "";
    tmp = tmp+media;
    result = tmp + result;
    i = i / 10;
  }
  return result;
}

//this function for expressions that have the string operands, the value of point = true  

template<class T> 
void Interface<T>::strToExp(string str, std::vector<string>&exp, 
                             bool point=false)
{
  string operand="";
  exp.clear();
  for(int unsigned i=0;i<str.size();++i)
     {
       string tmp="";tmp=tmp+str[i];
       if(!point) exp.insert(exp.end(),tmp);
       else 
         {
	    if(str[i]==')'||str[i]=='(') 
              { exp.insert(exp.end(),tmp); continue;} 
            if(str[i]!='.'&&str[i]!=STAR&&str[i]!=ADDITION) 
               operand = operand + str[i]; 
            else 
              { 
                //attention : aa*.bb 
                if(!operand.empty()) 
                   { exp.insert(exp.end(),operand); operand="";}
                if(tmp!=".") exp.insert(exp.end(),tmp); 
              }
	 } 
     } 
}








